#use "zlib1.lib" // dll imports
#use "ws2_32.lib"

#typedef gzFile pointer
#typedef HANDLE int
#typedef BOOL int
#typedef SOCKET int
#typedef HWND int
#typedef LPCSTR pointer
#typedef LPCVOID pointer
#typedef LPVOID pointer
#typedef LPSTR pointer

#define ZLIB_VERSION "1.2.3"

declare cdecl import, gzopen(string path, string mode),gzFile;
declare cdecl import, gzread(gzFile file, void *buf, unsigned int length),int;
declare cdecl import, gzclose(gzFile file),int;
declare cdecl import, gzerror(gzFile file, int *errnum),string *;
declare cdecl import, inflateInit_(z_stream* strm,string *version,int stream_size),int;
declare cdecl import, inflate(z_stream* strm, int flush),int;
declare cdecl import, inflateEnd(z_stream* strm),int;
declare cdecl import, zError(int error),string*;

declare import,WSAStartup(unsigned word wVersionRequested,WSADATA *lpWSAData),int;
declare import,closesocket(SOCKET s),int;
declare import,connect(SOCKET s,sockaddr *name,int namelen),int;
declare import,gethostbyname(char *name),hostent *;
declare import,inet_addr(char *cp),unsigned int;
declare import,socket(int af,int type, int protocol),SOCKET; 
declare import,WSACleanup(),int;
declare import,htons(word hostshort),word;
declare import,send(SOCKET s,char *buf,int _len,int flags),int;
declare import,recv(SOCKET s,char *buf,int _len,int flags),int;

declare import,GetFileSize(HANDLE hFile,DWORD *lpFileSizeHigh),DWORD; 
declare import,MessageBoxA(HWND hWnd,LPCSTR lpText,LPCSTR lpCaption,UINT uType),int;
declare import,WriteFile(HANDLE hFile,LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite,DWORD *lpNumberOfBytesWritten,OVERLAPPED *lpOverlapped),BOOL;
declare import,ReadFile(HANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,DWORD *lpNumberOfBytesRead,OVERLAPPED *lpOverlapped),BOOL;
declare import,SetEndOfFile(HANDLE hFile),BOOL; 
declare import,MoveFile alias MoveFileA(LPCSTR lpExistingFileName,LPCSTR lpNewFileName),BOOL;
declare import,FormatMessage alias FormatMessageA(DWORD dwFlags,LPCVOID lpSource,DWORD dwMessageId,DWORD dwLanguageId,LPSTR lpBuffer,DWORD nSize,va_list *Arguments),DWORD;
declare import,GetLastError(),DWORD;

import int     cdecl isdigit(int i);
import int     cdecl system( byte *c);
import int     cdecl memset(void *a, int b, int n);
import pointer cdecl strchr(byte *q, int w);
import int     cdecl memcmp(void *a, void *b, int n);
import int     cdecl memcpy(void *a, void *b, int n);
import pointer cdecl strstr(char *q, char *w); 

#define AF_INET     2
#define SOCK_STREAM 1
#define IPPROTO_TCP 6
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1
#define FORMAT_MESSAGE_FROM_SYSTEM     0x00001000
#define Z_NO_COMPRESSION         0
#define Z_NO_FLUSH      0
#define Z_FINISH        4

struct in_addr,1 {
	int S_addr[0];
	byte s_b1;
	byte s_b2;
	byte s_b3;
	byte s_b4;
}


struct sockaddr_in {
	word   sin_family;
	word sin_port;
	in_addr sin_addr;
	byte    sin_zero[8];
}
struct  hostent {
	byte  *h_name;          // official name of host
	byte  *h_aliases;       // alias list
	word  h_addrtype;      // host address type
	word  h_length;        // length of address
//	char  *h_addr_list[0];  // list of addresses
//	char  *h_addr;          // address, for backward compat
	DWORD *h_addr_list[0];  // list of addresses
	DWORD *h_addr;          // address, for backward compat
}
struct sockaddr {
	word sa_family;              /* address family */
	byte sa_data[14];            /* up to 14 bytes of direct address */
}
struct z_stream,4
{
    DWORD *next_in;   // next input byte
    DWORD  avail_in;  // number of bytes available at next_in
    DWORD  total_in;  // total nb of input bytes read so far

    DWORD *next_out;  // next output byte should be put there
    DWORD  avail_out; // remaining free space at next_out
    DWORD  total_out; // total nb of bytes output so far

    string *msg;      // last error message, NULL if no error
    DWORD  *state;    // not visible by applications

    DWORD  zalloc;    // used to allocate the internal state
    DWORD  zfree;     // used to free the internal state
    DWORD *popaque;   // private data object passed to zalloc and zfree

    DWORD  data_type; // best guess about the data type: binary or text
    DWORD  adler;     // adler32 value of the uncompressed data
    DWORD  reserved;  // reserved for future use
}
extern int _astrlen(string *str);
extern int __try();
extern void __leave();
extern void __throw(string *message);
extern int __catch(
	opt int *ppExceptionCode = NULL,  // pointer to integer
	opt int *ppExceptionAddress = NULL, // pointer to integer
	opt string *ppExceptionDescription = NULL); // pointer to string pointer

